#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include <objbase.h>
//#include "public.h"

#pragma warning(disable:4201)  // disable nameless struct/union warnings
#include <winioctl.h>
#include <setupapi.h>
#pragma warning(default:4201)


//Windows Header Files
#ifdef _WIN32
#ifndef _WIN32_WCE
#include <conio.h>
#endif

#include <windows.h>
#include <stdlib.h>
#include <math.h>
// diamond driver includes
//#include "dscud.h"
#endif



#define MAX_ISA_DEVICE 4

typedef struct _CANCONFIG
{
	unsigned int Can_ch;
	unsigned int BaudRate;
	unsigned int Rtr;
}CANCONFIG,*PCANCONFIG;

 

typedef struct _CANMESSAGE
{
	unsigned int Can_ch;
	unsigned int Rtr;
	unsigned int Msg_type;
	unsigned int Tb_Type; 
	unsigned int Msg_ID;
	unsigned int Msg_len;
	unsigned char Data[68];
}CANMESSAGE,*PCANMESSAGE;

typedef struct _PORT_CONFIG
{
	unsigned int Port;
	unsigned int Control;
	unsigned char data;
}PORTCONFIG,*PPORTCONFIG;

typedef struct _WD_TRANSFER
{
	unsigned int Can_ch;
	unsigned int offset;
	unsigned char rd_wr;
	unsigned char data;
}WD_TRANSFER,*PWD_TRANSFER;

typedef struct _CAN_BASE_ADDR
{
	unsigned char *base_addr;
	unsigned char *dio_base_addr;
}JNMMCANBASE,*PJNMMCANBASE;


// Structure and Function prototype/* CAN device statistics  */
typedef struct can_device_stats {
unsigned int txerr;    /* Tx errors */
unsigned int rxerr;    /* Rx errors */
unsigned int txpackets; /* Tx transmitted count */
unsigned int rxpackets;  /* Rx transmitted count */
unsigned int rx_over_errors; /* Rx over error count */
unsigned int error_active;  /* Error active enable */
unsigned int stat_change;  /*stat changed from passive to active ,vice versa */
unsigned int bit_error; /* bit error  */
unsigned int stuff_error; /* stuff error  */
unsigned int form_error; /* Form error  */
unsigned int bus_error;        /* Bus errors */
unsigned int bus_error_enable; /* bit error enable */
unsigned int error_warning;    /* Changes to error warning state */
unsigned int error_passive;    /* Changes to error passive state */
unsigned int bus_off;          /* Changes to bus off state */
unsigned int arbitration_lost; /* Arbitration lost errors */
unsigned int arbitration_lost_enable; /* arbitration lost error enable  */
}can_device_stats,*pcan_device_stats;

/* CAN strcuture for read/write the register from the driver to application vice versa */
typedef struct _CANRW
{
	unsigned int Can_ch;
	unsigned char offset;
	unsigned char data;
	
}CANRW,*PCANRW;

HANDLE __declspec(dllexport) JNMMCANOpen(int *flag);

int __declspec(dllexport) JNMMCANInit(int can_ch);

VOID __declspec(dllexport) JNMMCANClose(HANDLE hHandle);

BYTE __declspec(dllexport) JNMMCANErrorStat( HANDLE hDevice,CANCONFIG CanParam, can_device_stats* stats);


unsigned short __declspec(dllexport) JNMMGetFPGAVersion(HANDLE hHandle);

unsigned short __declspec(dllexport) JNMMGetBoardVersion(HANDLE hHandle);

BYTE __declspec(dllexport) JNMMCANBaseAddrInit(int base_address);

BYTE __declspec(dllexport) JNMMCANDIOAddrInit(int dio_base);

BYTE __declspec(dllexport) CAN_INIT(int index);



// PCI 
BOOL __declspec(dllexport) JNMMCANConfig(HANDLE hDevice,  CANCONFIG CanParam); 

BYTE __declspec(dllexport) JNMMCANTX(HANDLE hHandle, CANMESSAGE* msg);

BYTE __declspec(dllexport) JNMMCANRX(HANDLE hHandle, CANMESSAGE* msg);

BYTE __declspec(dllexport) JNMMCANRead(int can_ch,unsigned char offset);

BYTE __declspec(dllexport) JNMMCANWrite(int can_ch,unsigned char offset,unsigned char data);


//Digital I/O functions

BYTE __declspec(dllexport) JNMMGPIOConfig( int Port, int Config);

BYTE __declspec(dllexport) JNMMGPIORead( int Port,int * data);

BYTE __declspec(dllexport) JNMMGPIOWrite( int Port, int data);

BYTE __declspec(dllexport) JNMMGPIOWriteBit( int Port,int Bit, int data);

BYTE __declspec(dllexport) JNMMGPIOReadBit( int Port,int Bit,int * data);